clang-tools 8.0.0

Classes | Namespaces | Typedefs | Functions
ClangdUnit.h File Reference
`#include "Diagnostics.h"`
`#include "FS.h"`
`#include "Function.h"`
`#include "Headers.h"`
`#include "Path.h"`
`#include "Protocol.h"`
`#include "clang/Frontend/FrontendAction.h"`
`#include "clang/Frontend/PrecompiledPreamble.h"`
`#include "clang/Lex/Preprocessor.h"`
`#include "clang/Serialization/ASTBitCodes.h"`
`#include "clang/Tooling/CompilationDatabase.h"`
`#include "clang/Tooling/Core/Replacement.h"`
`#include <memory>`
`#include <string>`
`#include <vector>`
Include dependency graph for ClangdUnit.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
struct | clang::clangd::PreambleData
struct | clang::clangd::ParseInputs
| Information required to run clang, e.g. to parse AST or do code completion. More...
class | clang::clangd::ParsedAST
| Stores and provides access to parsed AST. More...

## Namespaces
| llvm
| Some operations such as code completion produce a set of candidates.
| llvm::vfs
| clang
| ===– Representation.cpp - ClangDoc Representation --------—*- C++ -*-===//
| clang::tooling
| clang::clangd

## Typedefs
using | clang::clangd::PreambleParsedCallback = std::function< void(ASTContext &, std::shared_ptr< clang::Preprocessor >)>

## Functions
std::unique_ptr< CompilerInvocation > | clang::clangd::buildCompilerInvocation (const ParseInputs &Inputs)
| Builds compiler invocation that could be used to build AST or preamble. More...
std::shared_ptr< const PreambleData > | clang::clangd::buildPreamble (PathRef FileName, CompilerInvocation &CI, std::shared_ptr< const PreambleData > OldPreamble, const tooling::CompileCommand &OldCompileCommand, const ParseInputs &Inputs, std::shared_ptr< PCHContainerOperations > PCHs, bool StoreInMemory, PreambleParsedCallback PreambleCallback)
| Rebuild the preamble for the new inputs unless the old one can be reused. More...
llvm::Optional< ParsedAST > | clang::clangd::buildAST (PathRef FileName, std::unique_ptr< CompilerInvocation > Invocation, const ParseInputs &Inputs, std::shared_ptr< const PreambleData > Preamble, std::shared_ptr< PCHContainerOperations > PCHs)
| Build an AST from provided user inputs. More...
SourceLocation | clang::clangd::getBeginningOfIdentifier (ParsedAST &Unit, const Position &Pos, const FileID FID)
| Get the beginning SourceLocation at a specified `Pos`. More...
void | clang::clangd::dumpAST (ParsedAST &AST, llvm::raw_ostream &OS)
| For testing/debugging purposes. More...